unit Slave1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, Menus, Math, StdCtrls, Main1, Fraction, Help1, XPMan;

type
  TForm2 = class(TForm)
    Table1: TStringGrid;
    MainMenu1: TMainMenu;
    NewMatrix1: TMenuItem;
    UnDo1: TMenuItem;
    Help1: TMenuItem;
    procedure DrawTable(row, col: integer);
    procedure CleanTable();
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure NewMatrix1Click(Sender: TObject);
    function IsTableFill(): Boolean;
    function CheckStrSintax(s: string): Boolean;
    function CheckTableFields(): Boolean;
    procedure Table1KeyPress(Sender: TObject; var Key: Char);
    procedure UnDo1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  const LMargin: integer = 5;
  const RMargin: integer = 13;
  const TMargin: integer = 5;
  const BMargin: integer = 59;
  const fline: char = '/';
var
  Form2: TForm2;
  PrevMatrix: TMatrix;

implementation

{$R *.dfm}

{This procedure draw table in Form2}
procedure TForm2.DrawTable(row, col: integer);
var
  cwidth, cheight: integer;
begin
  if col>14 then
    cwidth := 55
  else
    cwidth := 70;
  cheight := 18;

  Table1.FixedCols := 0;
  Table1.FixedRows := 0;
  Table1.RowCount := row;
  Table1.ColCount := col;
  Table1.DefaultColWidth := cwidth;
  Table1.DefaultRowHeight := cheight;
  Table1.Height := row*(cheight+1) + 1;
  Table1.Width := col*(cwidth+1) + 1;
  Table1.Left := LMargin;
  Table1.Top := TMargin;
  Table1.Ctl3D := False;
  Table1.Options := Table1.Options + [goEditing] + [goTabs] - [goRangeSelect];
  Form2.Width := LMargin + Table1.Width + RMargin;
  Form2.Height := TMargin + Table1.Height + BMargin;
end;

{This procedure clean all fields in table}
procedure TForm2.CleanTable();
var
  i: integer;
begin
  for i:=0 to (Table1.ColCount-1) do
    Table1.Cols[i].Clear;
end;

{This procedure will be call when you click on 'close button of Form2'}
procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form1.Close;
end;

{This procedure will be call when you chose 'New Matrix' from mani}
procedure TForm2.NewMatrix1Click(Sender: TObject);
begin
  if (MessageDlg('Do you really want to create new matrix?', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
  begin
    Form1.Visible := True;
    Form2.Visible := False;
  end;
end;

{Check is table completely fill}
function TForm2.IsTableFill(): Boolean;
var
  i,j: integer;
  ans: boolean;
begin
  ans := True;
  for i:=0 to (Table1.ColCount-1) do
  begin
    for j:=0 to (Table1.RowCount-1) do
    begin
      if Table1.Cells[i,j]='' then
        ans := False;
    end;
  end;
  Result := ans;
end;

function TForm2.CheckStrSintax(s: string): Boolean;
var
  i,stpos: integer;
  error, count: integer;
begin
  error:=0;
  count := 0;
  if s[1]='-' then
  begin
    stpos := 2;
    if (s[2]=fline) or (s[Length(s)]=fline) then Inc(error);
  end
  else
  begin
    stpos:= 1;
    if (s[1]=fline) or (s[Length(s)]=fline) then Inc(error);
  end;
  for i:=stpos to Length(s) do
  begin
    if(s[i] in ['0'..'9',fline]) then
    begin
      if s[i]=fline then Inc(count);
    end
    else
      Inc(error);
  end;
  if count>1 then Inc(error);
  if(s[Length(s)]='0') and (s[Length(s)-1]=fline) then Inc(error);
  if error=0 then Result := True
  else Result := False;
end;

function TForm2.CheckTableFields(): Boolean;
var
  i,j,error: integer;
  ans: Boolean;
begin
  error := 0;
  for i:=0 to (Table1.ColCount-1) do
  begin
    for j:=0 to (Table1.RowCount-1) do
    begin
      ans := CheckStrSintax(Table1.Cells[i,j]);
      if(not ans) then Inc(error);
    end;
  end;
  if error=0 then Result := True
  else Result := False;
end;

{Actualy, this is  the most important procedure in all aplicattion}
{This procedure will be call when you select filed in the martix, which}
{represent a pivot, and then press enter}
procedure TForm2.Table1KeyPress(Sender: TObject; var Key: Char);
var
  Matrix1: TMatrix;
  pivot,tmp1,tmp2: TFraction;
  acol,arow: integer;
  i: integer;
begin
  if Key = #13 then  // if Enter press do this, else nothing...
  begin
    if IsTableFill() then
    begin
      if CheckTableFields() then
      begin
        acol := Table1.Col;
        arow := Table1.Row;
        pivot := TFraction.Create();
        pivot.StrToFraction(Table1.Cells[acol,arow]);
        if(pivot.Numerator<>0) then
        begin
          tmp1 := TFraction.Create();
          tmp2 := TFraction.Create();
          PrevMatrix := TMatrix.Create(COL_Cnt, ROW_Cnt);
          Matrix1 := TMatrix.Create(COL_Cnt,ROW_Cnt);

          PrevMatrix.CopyFromTable(Table1,PrevMatrix);
          Matrix1.CopyFromTable(Table1,Matrix1);

          Matrix1.SwapRows(Matrix1.Row-1,arow,Matrix1);
          for i:=0 to (Matrix1.Row-2) do
          begin
            tmp2.DivFraction(tmp1.ChangeSign(Matrix1.Fields[acol][i]),pivot);
            if (tmp2.Numerator<>0) then
            begin
              Matrix1.ScalarXVector(tmp2,Matrix1.Row-1,Matrix1);
              Matrix1.AddTwoVectors(i,Matrix1.Row-1,Matrix1);
              tmp1.Swap(tmp2);
              Matrix1.ScalarXVector(tmp1,Matrix1.Row-1,Matrix1);
            end;
          end;
          tmp1.Swap(pivot);
          Matrix1.ScalarXVector(tmp1,Matrix1.Row-1,Matrix1);
          Matrix1.SwapRows(arow,Matrix1.Row-1,Matrix1);
          Matrix1.CopyToTable(Table1,Matrix1);
          UnDo1.Enabled := True;
        end
        else
          MessageDlg('Pivot can not be zero!',mtInformation,[mbOK],0);
      end
      else
        MessageDlg('Some values inside the matrix are not correctly!'+ #13#10#9 +
                   'Please check your matrix.',mtInformation,[mbOK],0);
    end
    else
      MessageDlg('    The matrix is not completely filled so you can not do pivoting!' +#13#10
               + 'Please enter the values in to the empty fields of matrix and try again.',mtInformation,[mbOK],0);
  end;
end;

procedure TForm2.UnDo1Click(Sender: TObject);
begin
  UnDo1.Enabled := False;
  PrevMatrix.CopyToTable(Table1,PrevMatrix);
end;

procedure TForm2.Help1Click(Sender: TObject);
begin
  Form3.Visible := True;
end;

end.
